/* Tunguska, ternary virtual machine
 *
 * Copyright (C) 2007,2008 Viktor Lofgren
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef display_h
#define display_h
#include "machine.h"
#include "SDL.h"

#define XRES 640
#define YRES 480
#define ROWS 27
#define COLS 54

class display {
public:
	display();
	~display();
	
	void printscreen(machine& m);
	void fullscreen() { SDL_WM_ToggleFullScreen(window); }
protected:
	SDL_Surface* window;
	SDL_Surface* symbols;

	void putcxy(int character, int x, int y);
	

	short buffer[ROWS*COLS];
};

#endif
